From 44398b0c34f11865aa4e35e6ce17369544940a17 Mon Sep 17 00:00:00 2001
From: Bharath Rupireddy <bharath.rupireddyforpostgres@gmail.com>
Date: Sat, 12 Feb 2022 11:19:51 +0000
Subject: [PATCH v1] Add comment about startup process getting procState array
 slot

---
 src/backend/storage/ipc/standby.c | 8 ++++++++
 1 file changed, 8 insertions(+)

diff --git a/src/backend/storage/ipc/standby.c b/src/backend/storage/ipc/standby.c
index 87ac0f74b2..bd41a1f060 100644
--- a/src/backend/storage/ipc/standby.c
+++ b/src/backend/storage/ipc/standby.c
@@ -94,6 +94,14 @@ InitRecoveryTransactionEnvironment(void)
 									&hash_ctl,
 									HASH_ELEM | HASH_BLOBS);
 
+	/*
+	 * Here, the startup process is guaranteed to get a free procSatate array
+	 * slot, even though SInvalShmemSize has not accounted for it. This is
+	 * because autovacuum launcher/worker processes will not get started in
+	 * standby mode for which procSatate array slots have already been
+	 * allocated.
+	 */
+
 	/*
 	 * Initialize shared invalidation management for Startup process, being
 	 * careful to register ourselves as a sendOnly process so we don't need to
-- 
2.25.1

